org.apache.hc.client5.http.io

## Class ConnectionEndpoint

- java.lang.Object
- - org.apache.hc.client5.http.io.ConnectionEndpoint

All Implemented Interfaces:
  Closeable, AutoCloseable, org.apache.hc.core5.io.ModalCloseable

    @Contract(threading=SAFE)
    public abstract class ConnectionEndpoint
    extends Object
    implements org.apache.hc.core5.io.ModalCloseable

Client endpoint leased from a connection manager. Client points can be used to execute HTTP requests.

Once the endpoint is no longer needed it MUST be released with `ModalCloseable.close(org.apache.hc.core5.io.CloseMode)` )}.

Since:
  5.0

### Nested Class Summary

Nested Classes
`static interface` `ConnectionEndpoint.RequestExecutor`

### Constructor Summary

Constructors
Constructor and Description
`ConnectionEndpoint()`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods Deprecated Methods
`org.apache.hc.core5.http.ClassicHttpResponse` `execute(String id, org.apache.hc.core5.http.ClassicHttpRequest request, ConnectionEndpoint.RequestExecutor requestExecutor, org.apache.hc.core5.http.protocol.HttpContext context)` Executes HTTP request using the provided request executor.
`abstract org.apache.hc.core5.http.ClassicHttpResponse` `execute(String id, org.apache.hc.core5.http.ClassicHttpRequest request, org.apache.hc.core5.http.impl.io.HttpRequestExecutor executor, org.apache.hc.core5.http.protocol.HttpContext context)` Deprecated. Use `execute(String, ClassicHttpRequest, RequestExecutor, HttpContext)`
`EndpointInfo` `getInfo()` Returns information about the endpoint or `null` when not connected.
`abstract boolean` `isConnected()` Determines if the connection to the remote endpoint is still open and valid.
`abstract void` `setSocketTimeout(org.apache.hc.core5.util.Timeout timeout)` Sets the socket timeout value.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.apache.hc.core5.io.ModalCloseable

`close`

### Methods inherited from interface java.io.Closeable

`close`

### Constructor Detail

#### ConnectionEndpoint

    public ConnectionEndpoint()

### Method Detail

#### execute

    @Deprecated
    public abstract org.apache.hc.core5.http.ClassicHttpResponse execute(String id,
                                                                                     org.apache.hc.core5.http.ClassicHttpRequest request,
                                                                                     org.apache.hc.core5.http.impl.io.HttpRequestExecutor executor,
                                                                                     org.apache.hc.core5.http.protocol.HttpContext context)
                                                                              throws IOException,
                                                                                     org.apache.hc.core5.http.HttpException

Deprecated. Use `execute(String, ClassicHttpRequest, RequestExecutor, HttpContext)`

Throws:
  `IOException`
  `org.apache.hc.core5.http.HttpException`

#### execute

    public org.apache.hc.core5.http.ClassicHttpResponse execute(String id,
                                                                org.apache.hc.core5.http.ClassicHttpRequest request,
                                                                ConnectionEndpoint.RequestExecutor requestExecutor,
                                                                org.apache.hc.core5.http.protocol.HttpContext context)
                                                         throws IOException,
                                                                org.apache.hc.core5.http.HttpException

Executes HTTP request using the provided request executor.

Once the endpoint is no longer needed it MUST be released with `ModalCloseable.close(org.apache.hc.core5.io.CloseMode)`.

Parameters:
  `id` - unique operation ID or `null`.
  `request` - the request message.
  `requestExecutor` - the request executor.
  `context` - the execution context.
Throws:
  `IOException`
  `org.apache.hc.core5.http.HttpException`
Since:
  5.4

#### isConnected

    public abstract boolean isConnected()

Determines if the connection to the remote endpoint is still open and valid.

#### setSocketTimeout

    public abstract void setSocketTimeout(org.apache.hc.core5.util.Timeout timeout)

Sets the socket timeout value.

Parameters:
  `timeout` - timeout value

#### getInfo

    public EndpointInfo getInfo()

Returns information about the endpoint or `null` when not connected.

Since:
  5.4